# ]po[ Petri-Net Workflow
This package is part of ]project-open[, an open-source enterprise project management system.

For more information about ]project-open[ please see:
* [Documentation Wiki](https://www.project-open.com/en/)
* [V5.0 Download](https://sourceforge.net/projects/project-open/files/project-open/V5.0/)
* [Installation Instructions](https://www.project-open.com/en/list-installers)

About ]po[ Petri-Net Workflow:

<p>This &quot;intranet-workflow&quot; <a href="/en/object-type-apm-package">object-type-apm-package</a> contains functionality to integrate the original OpenACS <a href="/en/package-acs-workflow">acs-workflow</a> package into ]project-open[. <p>Other documents related to workflows include: <p><p>

# Online Reference Documentation

## Procedure Files

<table cellpadding="0" cellspacing="0"><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=55551&amp;path=packages/intranet-workflow/tcl/intranet-workflow-notification-procs.tcl">tcl/intranet-workflow-notification-procs.tcl</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/procs-file-view?version_id=55551&amp;path=packages/intranet-workflow/tcl/intranet-workflow-procs.tcl">tcl/intranet-workflow-procs.tcl</a></b></td><td></td><td></td></tr></table>

## Procedures

<table cellpadding="0" cellspacing="0"><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=55551&amp;proc=im_package_workflow_id">im_package_workflow_id</a></b></td><td></td><td>Returns the package id of the intranet-workflow module </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=55551&amp;proc=im_workflow::notification::get_url">im_workflow::notification::get_url</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=55551&amp;proc=im_workflow::notification::process_reply">im_workflow::notification::process_reply</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=55551&amp;proc=im_workflow_action_component">im_workflow_action_component</a></b></td><td></td><td>Shows WF default actions for the specified object, or a user-defined action panel if configured in the WF.&lt;p&gt; There are 5 different cases to deal with: - Enable: The user needs to press the &quot;Start&quot; button to take ownership of that task. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=55551&amp;proc=im_workflow_cancel_workflow">im_workflow_cancel_workflow</a></b></td><td></td><td>Cancel the workflow in case the underlying object gets closed, such like a ticket of a deleted project. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=55551&amp;proc=im_workflow_graph_component">im_workflow_graph_component</a></b></td><td></td><td>Show a Graphical WF representation of a workflow associated with an object. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=55551&amp;proc=im_workflow_graph_sort_order">im_workflow_graph_sort_order</a></b></td><td></td><td>Update the &quot;sort_order&quot; field in wf_transitions in order to reflect their distance from &quot;start&quot;, including places like nodes. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=55551&amp;proc=im_workflow_home_component">im_workflow_home_component</a></b></td><td></td><td>Creates a HTML table showing all currently active tasks </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=55551&amp;proc=im_workflow_home_inbox_component">im_workflow_home_inbox_component</a></b></td><td></td><td>Returns a HTML table with the list of workflow tasks for the current user. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=55551&amp;proc=im_workflow_journal_component">im_workflow_journal_component</a></b></td><td></td><td>Show the WF Journal for an object </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=55551&amp;proc=im_workflow_list_options">im_workflow_list_options</a></b></td><td></td><td>Returns a list of workflows that satisfy certain conditions </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=55551&amp;proc=im_workflow_new_journal">im_workflow_new_journal</a></b></td><td></td><td>Creates a new journal entry that can be passed to PL/SQL routines </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=55551&amp;proc=im_workflow_object_permissions">im_workflow_object_permissions</a></b></td><td></td><td>Determines whether a user can execute the specified &quot;perm_letter&quot; (i.e. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=55551&amp;proc=im_workflow_pretty_name">im_workflow_pretty_name</a></b></td><td></td><td>Returns a pretty name for the WF </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=55551&amp;proc=im_workflow_replace_translations_in_string">im_workflow_replace_translations_in_string</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=55551&amp;proc=im_workflow_replace_translations_in_string_helper">im_workflow_replace_translations_in_string_helper</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=55551&amp;proc=im_workflow_replacing_vacation_users">im_workflow_replacing_vacation_users</a></b></td><td></td><td>Returns the list of users that the current_user_id is replacing. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=55551&amp;proc=im_workflow_skip_first_transition">im_workflow_skip_first_transition</a></b></td><td></td><td>Skip the first tasks of the workflow. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=55551&amp;proc=im_workflow_start_wf">im_workflow_start_wf</a></b></td><td></td><td>Start a new WF for an object. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=55551&amp;proc=im_workflow_status_options">im_workflow_status_options</a></b></td><td></td><td>Returns a list of stati (actually: Places) for the given workflow </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=55551&amp;proc=im_workflow_status_select">im_workflow_status_select</a></b></td><td></td><td>Returns an html select box named $select_name and defaulted to $default with a list of all the project_types in the system </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=55551&amp;proc=im_workflow_stuck_p">im_workflow_stuck_p</a></b></td><td></td><td>Checks whether the workflow is &quot;stuck&quot;. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=55551&amp;proc=im_workflow_task_action">im_workflow_task_action</a></b></td><td></td><td>Similar to wf_task_action, but without checking if the current_user_id is the holding user. </td></tr></table>

## SQL Files

<table cellpadding="0" cellspacing="0"><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-workflow&amp;url=postgresql/intranet-workflow-callbacks.sql&amp;version_id=55551">sql/postgresql/intranet-workflow-callbacks.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-workflow&amp;url=postgresql/intranet-workflow-create.sql&amp;version_id=55551">sql/postgresql/intranet-workflow-create.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-workflow&amp;url=postgresql/notifications-create.sql&amp;version_id=55551">sql/postgresql/notifications-create.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-workflow&amp;url=postgresql/upgrade/upgrade-5.0.1.0.1-5.0.1.0.2.sql&amp;version_id=55551">sql/postgresql/upgrade/upgrade-5.0.1.0.1-5.0.1.0.2.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-workflow&amp;url=postgresql/upgrade/upgrade-5.0.2.4.1-5.0.2.4.2.sql&amp;version_id=55551">sql/postgresql/upgrade/upgrade-5.0.2.4.1-5.0.2.4.2.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-workflow&amp;url=postgresql/upgrade/upgrade-5.0.2.4.2-5.0.2.4.3.sql&amp;version_id=55551">sql/postgresql/upgrade/upgrade-5.0.2.4.2-5.0.2.4.3.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-workflow&amp;url=postgresql/upgrade/upgrade-5.0.2.4.3-5.0.2.4.4.sql&amp;version_id=55551">sql/postgresql/upgrade/upgrade-5.0.2.4.3-5.0.2.4.4.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-workflow&amp;url=postgresql/workflow-duplicate_token_test_wf-create.sql&amp;version_id=55551">sql/postgresql/workflow-duplicate_token_test_wf-create.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-workflow&amp;url=postgresql/workflow-edi_message_workflow_v10_linear_wf-create.sql&amp;version_id=55551">sql/postgresql/workflow-edi_message_workflow_v10_linear_wf-create.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-workflow&amp;url=postgresql/workflow-expense_approval_wf-create.sql&amp;version_id=55551">sql/postgresql/workflow-expense_approval_wf-create.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-workflow&amp;url=postgresql/workflow-feature_request_wf-create.sql&amp;version_id=55551">sql/postgresql/workflow-feature_request_wf-create.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-workflow&amp;url=postgresql/workflow-project_approval_wf-create.sql&amp;version_id=55551">sql/postgresql/workflow-project_approval_wf-create.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-workflow&amp;url=postgresql/workflow-rfc_approval_wf-create.sql&amp;version_id=55551">sql/postgresql/workflow-rfc_approval_wf-create.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-workflow&amp;url=postgresql/workflow-ticket_generic_wf-create.sql&amp;version_id=55551">sql/postgresql/workflow-ticket_generic_wf-create.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-workflow&amp;url=postgresql/workflow-ticket_workflow_generic_wf-create.sql&amp;version_id=55551">sql/postgresql/workflow-ticket_workflow_generic_wf-create.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-workflow&amp;url=postgresql/workflow-timesheet_approval_wf-create.sql&amp;version_id=55551">sql/postgresql/workflow-timesheet_approval_wf-create.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-workflow&amp;url=postgresql/workflow-vacation_approval_wf-create.sql&amp;version_id=55551">sql/postgresql/workflow-vacation_approval_wf-create.sql</a></b></td><td></td><td></td></tr></table>

## Content Pages

<table cellpadding="0" cellspacing="0"><tr valign="top"><td><b>www/</b></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=55551&amp;path=packages/intranet-workflow/www/flatten_wf.tcl">flatten_wf.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=55551&amp;path=packages/intranet-workflow/www/inbox-action.tcl">inbox-action.tcl</a></b></td><td>Delete a specific task from an inbox</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=55551&amp;path=packages/intranet-workflow/www/index.adp">index.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=55551&amp;path=packages/intranet-workflow/www/index.tcl">index.tcl</a></b></td><td>Index page for a workflow.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=55551&amp;path=packages/intranet-workflow/www/new-workflow.tcl">new-workflow.tcl</a></b></td><td>Creates a new workflow for a given object</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=55551&amp;path=packages/intranet-workflow/www/reset-case-2.adp">reset-case-2.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=55551&amp;path=packages/intranet-workflow/www/reset-case-2.tcl">reset-case-2.tcl</a></b></td><td>View all the info about a specific project.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=55551&amp;path=packages/intranet-workflow/www/reset-case.adp">reset-case.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=55551&amp;path=packages/intranet-workflow/www/reset-case.tcl">reset-case.tcl</a></b></td><td>View all the info about a specific project.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=55551&amp;path=packages/intranet-workflow/www/task-cancel.tcl">task-cancel.tcl</a></b></td><td>Cancel a specific task</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=55551&amp;path=packages/intranet-workflow/www/workflow-gif.tcl">workflow-gif.tcl</a></b></td><td>Generates a GIF image displaying the workflow</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=55551&amp;path=packages/intranet-workflow/www/workflow-graph.adp">workflow-graph.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=55551&amp;path=packages/intranet-workflow/www/workflow-graph.tcl">workflow-graph.tcl</a></b></td><td></td></tr><tr valign="top"><td><b>workflow-panels/</b></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=55551&amp;path=packages/intranet-workflow/www/workflow-panels/hello-world.adp">hello-world.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=55551&amp;path=packages/intranet-workflow/www/workflow-panels/hello-world.tcl">hello-world.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=55551&amp;path=packages/intranet-workflow/www/workflow.adp">workflow.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=55551&amp;path=packages/intranet-workflow/www/workflow.tcl">workflow.tcl</a></b></td><td>Index page for a workflow.</td></tr></table>

